// altered code for transmiting data over an nrf24L01 chip
// https://www.circuitbasics.com/wireless-communication-between-two-arduinos/

// https://forum.arduino.cc/t/simple-nrf24l01-2-4ghz-transceiver-demo/405123

//nrf2401 transmitter:
#include <SPI.h>
#include <nRF24L01.h>
#include <RF24.h>


#define BAUDRATE 9600
#define CE 9
#define CSN 8
#define ADDRESS "link1"

#define SWITCH_PORT 2

RF24 transmitter(CE, CSN);  // CE, CSN

const byte linkAddress[6] = ADDRESS;


////////////////////////////////////////////////////
void setup() {
  Serial.begin(BAUDRATE);
  Serial.println("------Startup------");

  pinMode(SWITCH_PORT, INPUT);
  int data;
  // create nrf driver instance. handle error
  while (!transmitter.begin(CE, CSN)) {
    Serial.println("Error while creating nrf driver instance. Try again");
  }

  Serial.println("nrf.begin success.");



  transmitter.openWritingPipe(linkAddress);  //set the address
  //nrf.setPALevel(RF24_PA_LOW);   //keep tx level low to stop psu noise, can remove this but then put in decoupling caps
  // Options are: RF24_PA_MIN=-18dBm, RF24_PA_LOW=-12dBm,  RF24_PA_HIGH=0dBm.
  transmitter.setPALevel(RF24_PA_HIGH);
  transmitter.stopListening();  //act as a transmitter

  while (true) {
    // handle not connected chip
    if (transmitter.isChipConnected()) {

      if (digitalRead(SWITCH_PORT)) {
        data = 1;
      }

      else {
        data = 0;
      }

      transmitter.write(&data, sizeof(data));  //spit out the data array
    }

    else {
      // display error message
      Serial.println("Error. Chip is not connected to SPI bus. Try again.");
    }
    delay(200);
  }
}
///////////////////////////////////////////////////
void loop() {
}
